import java.util.Vector;


public class Histogram{
    String name;
    double density[];
    double mids[];
    double mean;

    public Histogram(Vector <Double> numbers, int nBins, double min, double max){
	this.name="hist";
	density=new double[nBins];
	mids   =new double[nBins];
	double binMin, binMax;
	
	double span=max-min;
	double binSize=span/(double)nBins;
	mean=0.;
	for (int i=0;i<nBins;i++){
	    mids[i]=min+(0.5+(double)i)*binSize;
	    density[i]=0.;
	    binMin=mids[i]-0.5*binSize;
	    binMax=mids[i]+0.5*binSize;
	    for (int j=0;j<numbers.size();j++){
		if (numbers.elementAt(j)>=binMin && numbers.elementAt(j)<binMax) density[i]+=1.0;
	    }
	    density[i]/=(double)(numbers.size());
	}
	for (int j=0;j<numbers.size();j++){
	    mean+=numbers.elementAt(j);
	}
	mean/=(double)(numbers.size());	

    }

    public Histogram(Vector <Double> numbers, int nBins, double min, double max, boolean norm){
	this.name="hist";
	density=new double[nBins];
	mids   =new double[nBins];
	double binMin, binMax;
	
	double span=max-min;
	double binSize=span/(double)nBins;
	mean=0.;
	for (int i=0;i<nBins;i++){
	    mids[i]=min+(0.5+(double)i)*binSize;
	    density[i]=0.;
	    binMin=mids[i]-0.5*binSize;
	    binMax=mids[i]+0.5*binSize;
	    for (int j=0;j<numbers.size();j++){
		if (numbers.elementAt(j)>=binMin && numbers.elementAt(j)<binMax) density[i]+=1.0;
	    }
	    if (norm) density[i]/=(double)(numbers.size());
	}
	for (int j=0;j<numbers.size();j++){
	    mean+=numbers.elementAt(j);
	}
	mean/=(double)(numbers.size());	

    }

    public Histogram(Vector <Double> numbers, Vector <Double> categories, String name){
	this.name=name;
	int nBins=categories.size();
	density=new double[nBins];
	mids   =new double[nBins];
	double binMin, binMax;
	
	//double span=max-min;
	//double binSize=span/(double)nBins;
	mean=0.;
	for (int i=0;i<nBins;i++){
	    mids[i]=categories.elementAt(i);
	    density[i]=0.;
	    //binMin=mids[i]-0.5*binSize;
	    //binMax=mids[i]+0.5*binSize;
	    for (int j=0;j<numbers.size();j++){
		////System.out.println(numbers.elementAt(j)+ "  "+categories.elementAt(i));
		if ((int)Math.round(numbers.elementAt(j))==(int)Math.round(categories.elementAt(i))) density[i]+=1.0;
	    }
	    density[i]/=(double)(numbers.size());
	}
	for (int j=0;j<numbers.size();j++){
	    mean+=numbers.elementAt(j);
	}
	mean/=(double)(numbers.size());	

 }


    public Histogram(Vector <Double> numbers, Vector <Double> categories, double norm, String name){
	this.name=name;
	int nBins=categories.size();
	density=new double[nBins];
	mids   =new double[nBins];
	double binMin, binMax;
	
	//double span=max-min;
	//double binSize=span/(double)nBins;
	mean=0.;
	for (int i=0;i<nBins;i++){
	    mids[i]=categories.elementAt(i);
	    density[i]=0.;
	    //binMin=mids[i]-0.5*binSize;
	    //binMax=mids[i]+0.5*binSize;
	    for (int j=0;j<numbers.size();j++){
		////System.out.println(numbers.elementAt(j)+ "  "+categories.elementAt(i));
		if ((int)Math.round(numbers.elementAt(j))==(int)Math.round(categories.elementAt(i))) density[i]+=1.0;
	    }
	    density[i]/=norm;
	}
	for (int j=0;j<numbers.size();j++){
	    mean+=numbers.elementAt(j);
	}
	mean/=norm;	

 }

    public Histogram(Vector <Double> numbers, int nBins, double min, double max, String name){
	this(numbers, nBins, min, max);
	this.name=name;
    }
}