import java.util.Vector;

public class HostMute extends Host{       

    public HostMute(){
    }

    public void addMutePhage(double time, double waitingTime, int phageID, BinarySearchTree t, double expLev){
	
	if (!(this.p!=null && this.p.slumber) && !(this.p!=null && this.p.phageID==phageID)){ // bacterial debris on the site blocks occupation with new bacteria, don't add phage to sites where the same phage is already active	

	    if (this.p==null && this.b!=null){ // only sites without phages present can be invaded
		this.p=new MutePhage();
		
		this.p.init(x,y,time,waitingTime,phageID,this.b,Nneighbors,neighbors,neighborHosts,t,expLev);       
		if (p.populationStatus==0) p=null;
		checkPopulation();
		checkColor();
	    }
	}
    }


    public void addMutePhage2(double time, double waitingTime, int phageID, BinarySearchTree t, double expLev){
	
	if (!(this.p!=null && this.p.slumber) && !(this.p!=null && this.p.phageID==phageID)){ // bacterial debris on the site blocks occupation with new bacteria, don't add phage to sites where the same phage is already active

	    if (this.p==null && this.b!=null){ // only sites without phages present can be invaded
		this.p=new MutePhage2();
		
		this.p.init(x,y,time,waitingTime,phageID,this.b,Nneighbors,neighbors,neighborHosts,t,expLev);       
		if (p.populationStatus==0) p=null;
		checkPopulation();
		checkColor();
	    }
	}
    }

    public void addMutePhage3(double time, double waitingTime, int phageID, BinarySearchTree t, double expLev){
	
	if (!(this.p!=null && this.p.slumber) && !(this.p!=null && this.p.phageID==phageID)){ // bacterial debris on the site blocks occupation with new bacteria, don't add phage to sites where the same phage is already active

	    if (this.p==null && this.b!=null){ // only sites without phages present can be invaded
		this.p=new MutePhage3();
		
		this.p.init(x,y,time,waitingTime,phageID,this.b,Nneighbors,neighbors,neighborHosts,t,expLev);       
		if (p.populationStatus==0) p=null;
		checkPopulation();
		checkColor();
	    }
	}
    }


    public void addMuteBacteriaStandard(double time, int bactID, double expLevel, double waitingTime, Vector<Integer> imm, BinarySearchTree t, double rb, int nRes){
	if (this.b==null){
	    if (!(this.p!=null && this.p.slumber)){ // bacterial debris on the site blocks occupation with new bacteria
		    if (bactID==3) this.b=new bactSwitcher();
		    this.b.init(x,y,time, bactID, expLevel, waitingTime, 1,100,imm, Nneighbors,neighbors,neighborHosts,t,rb,nRes);
		    checkPopulation();
		    checkColor();
		}
	}
    }


    public void addMute_nres_Bacteria(double time, int bactID, double expLevel, double waitingTime, Vector<Integer> imm, Vector<Integer> fam, BinarySearchTree t, double rb, int nRes, double immSwitchRate, double waitingTime0, double rPrime, int[][] attackSurvival,double cost){
	if (this.b==null){
	    if (!(this.p!=null && this.p.slumber)){ // bacterial debris on the site blocks occupation with new bacteria
		    if (bactID==5) this.b=new bactSwitcherMute_nres();
		    this.b.init(x,y,time, bactID, expLevel, waitingTime, 1,100,imm, fam, Nneighbors,neighbors,neighborHosts,t,rb,nRes,immSwitchRate,waitingTime0,rPrime, attackSurvival,cost);
		    checkPopulation();
		    checkColor();
	    }
	}
       
	if (this.b!=null){ // remove the false
	    //if (false){
	   
		if (bactID==5) {
		    boolean inserted=false;
		    bactSwitcherMute_nres dummy=new bactSwitcherMute_nres();
		    //System.out.println("te ");
		    inserted=dummy.init_Tent(x,y,time, bactID, expLevel, waitingTime, 1,100,imm, fam, Nneighbors,neighbors,neighborHosts,t,rb,nRes,immSwitchRate,this.b,waitingTime0,rPrime, attackSurvival,cost);
		    //if ((this.b).nRes>0 || dummy.nRes>0) System.out.println("inserted "+inserted);
		    checkPopulation();
		    if (inserted) {			
			this.b=null;this.b=dummy;
		    }
		    //checkPopulation();
		    checkColor();		    
		}
	}
    }
    
		    

    public void addMute_nres_BacteriaBurst(double time, int bactID, double expLevel, double waitingTime, Vector<Integer> imm, Vector<Integer> fam, BinarySearchTree t, double rb, int nRes, double immSwitchRate, double waitingTime0, double rPrime, int[][] attackSurvival,double cost,int bs){
	//System.out.println("test0");
	if (this.b==null){
	    if (!(this.p!=null && this.p.slumber)){ // bacterial debris on the site blocks occupation with new bacteria
		//	System.out.println("test1");
		    if (bactID==5) this.b=new bactBurstMute();
		    //System.out.println("test2");
		    this.b.init(x,y,time, bactID, expLevel, waitingTime, 1,100,imm, fam, Nneighbors,neighbors,neighborHosts,t,rb,nRes,immSwitchRate,waitingTime0,rPrime, attackSurvival,cost,bs);
		    //System.out.println("test3");
		    checkPopulation();
		    checkColor();
		    //System.out.println("adding burst mute bact");
	    }
	}
       
	if (this.b!=null){ // remove the false
	    //if (false){
	   
		if (bactID==5) {
		    boolean inserted=false;
		    bactBurstMute dummy=new bactBurstMute();
		    //System.out.println("te ");
		    inserted=dummy.init_Tent(x,y,time, bactID, expLevel, waitingTime, 1,100,imm, fam, Nneighbors,neighbors,neighborHosts,t,rb,nRes,immSwitchRate,this.b,waitingTime0,rPrime, attackSurvival,cost,bs);
		    //if ((this.b).nRes>0 || dummy.nRes>0) System.out.println("inserted "+inserted);
		    checkPopulation();
		    if (inserted) {			
			this.b=null;this.b=dummy;
		    }
		    //checkPopulation();
		    checkColor();		    
		}
	}
    }
    
	

    public void addMuteBacteria(double time, int bactID, double expLevel, double waitingTime, Vector<Integer> imm, BinarySearchTree t, double rb, int nRes){
	if (this.b==null){
	    if (!(this.p!=null && this.p.slumber)){ // bacterial debris on the site blocks occupation with new bacteria
		    if (bactID==4) this.b=new bactSwitcherPlus();
		    this.b.init(x,y,time, bactID, expLevel, waitingTime, 1,100,imm, Nneighbors,neighbors,neighborHosts,t,rb,nRes);
		    checkPopulation();
		    checkColor();
		}
	}
    }
}
