import java.io.*;  

public class ImagePrinter{
    String filename;
    boolean noData, writeHeader;
    
    public ImagePrinter(String filename, boolean writeHeader){
	this.filename=filename;
	this.writeHeader=writeHeader;
	this.noData=true;
	try {
	    FileWriter outFile = new FileWriter(filename,false);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }
    
  
    public void outputToFile(double[] pars, int L, Host[] h){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    if (noData && writeHeader){
		out.print("#");
		for (int i=0;i<pars.length;i++)    out.print(((double)((double)((int)(10000.*pars[i])))/10000.)+"\t");

		out.print("\n");
		noData=false;
	    }
	    
	    // Write text to file
	    for (int i=0;i<h.length;i++)  {
		out.print(h[i].x + "\t" + h[i].y + "\t" + h[i].colIndex +"\n");
		if ((i+1)%L==0) out.print("\n");
	    }
	    
	    
	    
	    
	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }
}
