// This example is from the book _Java in a Nutshell_ by David Flanagan.
// Written by David Flanagan.  Copyright (c) 1996 O'Reilly & Associates.
// You may study, use, modify, and distribute this example for any purpose.
// This example is provided WITHOUT WARRANTY either expressed or implied.

import java.applet.*;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import java.util.Hashtable;
import java.util.Vector;
import java.util.Random;
import java.util.Date;
import javax.swing.*;

import java.io.BufferedReader;
import java.io.FileReader;



// This is a simple example of allowing an applet to run as a standalone
// Java application.  The only problem is that when running standalone,
// it can't read applet parameters.
public class dataHandling extends Panel {


    public static void main(String args[]) {
        // applet = new rW_appl();
        //Frame frame = new Frame();
	Frame frame= new AppletFrame("data handling", 300, 300);
	//frame.add(af);
	frame.addWindowListener(new java.awt.event.WindowAdapter() {
		public void windowClosing(java.awt.event.WindowEvent e) {
		    System.exit(0);
		};
	    });

    }
}

class AppletFrame extends Frame {
    public AppletFrame(String title, int width, int height) { 
        // create the Frame with the specified title.
        super(title); 
        String runNumber="16_08_2011_";
        // Add a menubar, with a File menu, with a Quit button.
        //MenuBar menubar = new MenuBar();
        //Menu file = new Menu("File", true);
        //menubar.add(file);
        //file.add("Quit");
        //this.setMenuBar(menubar);

        // Add the applet to the window.  Set the window size.  Pop it up.
        //this.add("Center");
        this.setSize(width, height);
        this.setVisible(false);
        
        // Start the applet.
        //applet.init();
        //applet.start();

	//	BinarySearchTree tree,visited;
	//GraphNode dummy;
	//tree    = new BinarySearchTree( );


	//	BufferedReader readbuffer = new BufferedReader(new FileReader("myFile.txt"));
	//String strRead;

	Vector<Pha> phavec            = new Vector<Pha>();
	Vector<Bacterium> bactvec     = new Vector<Bacterium>();
	Vector<Integer> distvec       = new Vector<Integer>();
	Vector<int2D> geodistvec      = new Vector<int2D>();

	int L=400;
	int NPHAGE=40;

	outputWriter oW,oW1,oW_densityFluc, oW_phageDensityFluc;

	String standardFilename = ".dat";

	boolean computeBacteria = true;
	boolean computePhage = false;
	String mainPath = "/home/haerter/work/CMOL_programs/phage/java/java_evol_bact/";

	if (computeBacteria){
	    oW      = new outputWriter("history_out_"+runNumber+"_"+standardFilename,true);
	    oW1     = new outputWriter("basic_out_"+runNumber+"_"+standardFilename,true);
	}
	else {
	    oW      = new outputWriter("dummy_out.dat",true);
	    oW1     = new outputWriter("basic_out.dat",true);
	}

	//File inputfile = new File("../java_evol_bact/out_scatter_test_15_09_2011_CRISPR_cost_.1__L500_mix_false_1b_evolBac_nres_nphage_60_nres_1_immSwRt0.1_wTMin_1.0_rbMin_1.0_rPrime_1.0E-5.dat");
	//	File inputfile = new File("out_scatter_test_15_09_2011_CRISPR_cost_.1__L400_mix_false_1b_evolBac_nres_nphage_40_nres_1_immSwRt0.1_wTMin_1.0_rbMin_1.0_rPrime_1.0E-5.dat");
	//	File inputfile = new File("out_scatter_test_15_09_2011_CRISPR_cost_.1__L300_mix_false_1b_evolBac_nres_nphage_20_nres_1_immSwRt0.1_wTMin_1.0_rbMin_1.0_rPrime_1.0E-5.dat");
	//File inputfile = new File("bact_scatter_40.dat");
	File inputphage = new File("test_phage_corr.dat");
	//File inputphage = new File("40_phage.dat");

	//	File inputfile = new File("out.dat");
	//File inputfile = new File("out_scatter_test_15_09_2011_CRISPR_cost_.025__L300_mix_false_1b_evolBac_nres_nphage_20_nres_1_immSwRt0.1_wTMin_1.0_rbMin_1.0_rPrime_1.0E-5.dat");
	//	File inputfile = new File("out_scatter_test_15_09_2011_CRISPR_cost_.025__L400_mix_false_1b_evolBac_nres_nphage_40_nres_1_immSwRt0.1_wTMin_1.0_rbMin_1.0_rPrime_1.0E-5.dat");
	
	File inputfile = new File("out_scatter_test_15_09_2011_CRISPR_cost_.025__L500_mix_false_1b_evolBac_nres_nphage_60_nres_1_immSwRt0.1_wTMin_1.0_rbMin_1.0_rPrime_1.0E-5.dat");

	    //	File inputfile = new File("out_scatter_test_31_08_2011_CRISPR_cost_.05__L400_mix_false_1b_evolBac_nres_nphage_20_nres_1_immSwRt0.01_wTMin_1.0_rbMin_2.0_rPrime_1.0E-5.dat");
	//File inputfile = new File("out_scatter_test_31_08_2011_CRISPR_cost_.05__L300_mix_false_1b_evolBac_nres_nphage_6_nres_1_immSwRt0.1_wTMin_1.0_rbMin_1.0_rPrime_1.0E-5.dat");
	//File inputfile = new File("out_scatter_test_31_08_2011_CRISPR_cost_.05__L300_mix_false_1b_evolBac_nres_nphage_20_nres_1_immSwRt0.1_wTMin_1.0_rbMin_1.0_rPrime_1.0E-5.dat");
	oW_densityFluc = new outputWriter("bactDensity_scaling_"+inputfile,true);
	oW_phageDensityFluc = new outputWriter("phageDensity_scaling_"+inputphage,true);
        StringBuffer contents = new StringBuffer();
        BufferedReader reader = null;
	
	if (computeBacteria){
	    try {
		reader = new BufferedReader(new FileReader(mainPath+inputfile));
		String text = null;
		
		// repeat until all lines read
		while ((text = reader.readLine()) != null) {
		    
		    String splitarray[] = text.split("\\s+");
		    
		    //System.out.println(splitarray);
		    
		    
		    String x_st     = splitarray[0];
		    String y_st     = splitarray[1];
		    String nres_st  = splitarray[2];
		    String r_st     = splitarray[3];
		    
		    int x      =  (int)Double.parseDouble(x_st);
		    int y      =  (int)Double.parseDouble(y_st);
		    int nres   =  (int)Double.parseDouble(nres_st);
		    double r   =  Double.parseDouble(r_st);
		    
		    Vector<Integer> family=new Vector<Integer>();
		    
		    for (int i=4;i<splitarray.length;i++){
			family.add(Integer.parseInt(splitarray[i]));
		    }
		    
		    Bacterium b = new Bacterium(x,y,nres,r,family);
		    bactvec.add(b);
		    
		    //		System.out.println("nodeWeight "+nodeWeight);
		    //System.out.println("sender "+sender);
		    //System.out.println("recipient "+recipient);
		    
		}
		
	    } catch (FileNotFoundException e) {
		e.printStackTrace();
	    } catch (IOException e) {
		e.printStackTrace();
	    } finally {
		try {
		    if (reader != null) {
			reader.close();
		    }
		} catch (IOException e) {
		    e.printStackTrace();
		}
	    }
	}

	if (computePhage){
	    try {
		reader = new BufferedReader(new FileReader(inputphage));
		String text = null;
		
		// repeat until all lines read
		while ((text = reader.readLine()) != null) {
		    
		    String splitarray[] = text.split("\\s+");
		    
		    //System.out.println(splitarray);
		    
		    
		    String x_st     = splitarray[0];
		    String y_st     = splitarray[1];
		    String nres_st  = splitarray[2];
		    
		    int x      =  (int)Double.parseDouble(x_st);
		    int y      =  (int)Double.parseDouble(y_st);
		    int nres   =  (int)Double.parseDouble(nres_st);		  
		    
		    
		    Pha p = new Pha(x,y,nres);
		    phavec.add(p);
		    
		    //		System.out.println("nodeWeight "+nodeWeight);
		    //System.out.println("sender "+sender);
		    //System.out.println("recipient "+recipient);
		    
		}
		
	    } catch (FileNotFoundException e) {
		e.printStackTrace();
	    } catch (IOException e) {
		e.printStackTrace();
	    } finally {
		try {
		    if (reader != null) {
			reader.close();
		    }
		} catch (IOException e) {
		    e.printStackTrace();
		}
	    }
	}

       	System.out.println("done");

	int c=0;
	for (double m=1;m<=Math.log(L);m+=.1) c+=1;
	double [][] means=new double[c][6];
	double [][] means_phage=new double[c][3];
	
	int [] l0vals=new int[c];
	int l0;
	c=0;
	for (double m=1;m<=Math.log(L);m+=.1){	    
	    l0=(int)Math.round(Math.exp(m));
	    l0vals[c]=l0;
	    if (computeBacteria) means[c]=getBactDiversity(bactvec,l0,L);
	    if (computePhage) means_phage[c]=getPhaDiversity(phavec,l0,L,NPHAGE);
	    //System.out.println("mean c" +means_phage[c][0]);
	    c+=1;
	    //System.out.println(l0+"  "+means[0]+"  "+means[1]+"  "+means[2]+"  "+means[3]);
	}
	if (computeBacteria){
	    oW_densityFluc.insertComment("# l0 meanMean  MeanStd  densStd  divstd  n0");
	    oW_densityFluc.outputToFileDoubleMatrix2D(l0vals,means,c,means[0].length,1.);
	}
	if (computePhage){
	    oW_phageDensityFluc.insertComment("# meanMean  n0");
	    oW_phageDensityFluc.outputToFileDoubleMatrix2D(l0vals,means_phage,c,means_phage[0].length,1.);
	}
	/*
	if (computeBacteria){
	    for (int or=0;or<bactvec.size();or+=1000){
		for (int nb=0;nb<bactvec.size();nb++){
		    distvec.add(distance(bactvec.elementAt(or),bactvec.elementAt(nb)));
		    geodistvec.add(geoDistance(bactvec.elementAt(or),bactvec.elementAt(nb),L));
		}
	    }
	    
	    oW.outputToFileScatter2DVector(geodistvec, distvec);       
	    oW1.outputToFileScatterVector(bactvec);
	}
	*/
    }

    double[] getBactDiversity(Vector<Bacterium> bact, int l, int L){
	double[][] std;
	double[][] mean;
	double[][] nel;
	double densMean;
	double densStd;
	double divStd;
	double divMean;
	int lx0,ly0;
	int n=(L-L%l)/l;
	int L0=n*l;
	int posx, posy,nres;
	int quadrant,quadrantx,quadranty;
	double meanStd,meanMean;
	double stdMean=0.;
	double totalMean=0.;
	double meanSq=0.;
	double [] means=new double[6];
	std =new double[n][n];
	mean=new double[n][n];
	nel =new double[n][n];
	int n0=0;
	densMean=0.;
	densStd =0.;
	divMean =0.;
	divStd  =0.;
	
	double currDens;
	
	Bacterium current;
		
	//	System.out.println("L0 ="+L0);
	for (int b=0;b<bact.size();b++){
	    current=bact.elementAt(b);
	    posx=current.x;
	    posy=current.y;
	    if (posx<L0 && posy<L0){
		nres=current.nres;
		quadrantx=(posx-posx%l)/l;
		quadranty=(posy-posy%l)/l;
		mean[quadrantx][quadranty]+=nres;
		std[quadrantx][quadranty]+=nres*nres;
		nel[quadrantx][quadranty]+=1.;
	    }
	}

	meanStd=0;
	meanMean=0;		

	for (int x=0;x<n;x++){
	    for (int y=0;y<n;y++){
		if (nel[x][y]>0){
		    currDens=nel[x][y]/(l*l);
		    densMean+=currDens;
		    densStd +=currDens*currDens;

		    mean[x][y]/=nel[x][y];
		    totalMean+=mean[x][y];
		    meanSq+=mean[x][y]*mean[x][y];
		    meanMean+=mean[x][y];
		    std[x][y]-=mean[x][y]*mean[x][y]*nel[x][y];		
		    std[x][y]/=(nel[x][y]);
		    divMean +=std[x][y];
		    divStd  +=std[x][y]*std[x][y];
		    meanStd+=std[x][y];
		    n0+=1;
		}
		//System.out.print(nel[x][y]+" "+Math.round(100.*std[x][y])/100.+" "+Math.round(100.*mean[x][y])/100.+"\n");
	    }
	    //	    System.out.println("\n");
	}
	totalMean/=n*n;

	stdMean=Math.sqrt(meanSq/(n*n)-totalMean*totalMean);
	System.out.println("stdMean "+stdMean+" meanTot "+totalMean);
	densMean/=n*n;
	divMean/=n0;
	densStd-=densMean*densMean*n*n;
	divStd -=divMean *divMean*n0;
	densStd/=n*n;
	divStd/=n0;

	//System.out.println("# n0 "+n0);
	meanMean/=(n0);
	meanStd /=(n0);
	
	means[0]=meanMean;
	means[1]=meanStd;
	means[2]=densStd;
	means[3]=divStd;
	means[4]=n0;
	means[5]=stdMean;
	return means;

    }



    double[] getPhaDiversity(Vector<Pha> pha, int l, int L, int np){
	double[][] std;
	double[][] mean;
	double[][] nel;
	double densMean;
	double densStd;
	double divStd;
	double divMean;
	int lx0,ly0;
	int n=(L-L%l)/l;
	int L0=n*l;
	int posx, posy,nres;
	int quadrant,quadrantx,quadranty;
	double meanStd,meanMean;
	int[][][] count= new int[n][n][np];
	int[][] div= new int[n][n];
	double [] means=new double[5];
	std =new double[n][n];
	mean=new double[n][n];
	nel =new double[n][n];
	double nelTot=0.;
	int n0=0;
	densMean=0.;
	densStd =0.;
	divMean =0.;
	divStd  =0.;
	
	double currDens;
	
	Pha current;
		
	for (int p=0;p<pha.size();p++){
	    current=pha.elementAt(p);
	    posx=current.x;
	    posy=current.y;
	    if (posx<L0 && posy<L0){
		nres=current.nres;
		quadrantx=(posx-posx%l)/l;
		quadranty=(posy-posy%l)/l;
		count[quadrantx][quadranty][nres]+=1;
		//		mean[quadrantx][quadranty]+=nres;
		//std[quadrantx][quadranty]+=nres*nres;
		nel[quadrantx][quadranty]+=1.;
		nelTot+=1.;
	    }
	}

	meanStd=0;
	meanMean=0;		

	for (int x=0;x<n;x++){
	    for (int y=0;y<n;y++){
		//if (nel[x][y]>0){
		for (int d=0;d<np;d++) {
		    if (count[x][y][d]>0) div[x][y]+=1;
		}
		divMean+=div[x][y];
		//}
		if (nel[x][y]>0){
		    currDens=nel[x][y]/(l*l);
		    densMean+=currDens;
		    densStd +=currDens*currDens;
		    
		    //   mean[x][y]/=nel[x][y];
		    //meanMean+=mean[x][y];
		    //std[x][y]-=mean[x][y]*mean[x][y]*nel[x][y];		
		    //std[x][y]/=(nel[x][y]);
		    //divMean +=std[x][y];
		    //divStd  +=std[x][y]*std[x][y];
		    //meanStd+=std[x][y];
		    n0+=1;
		}
	    }
	}
	System.out.println("div Mean "+divMean);
	divMean/=n*n;
	System.out.println("div Mean "+divMean);
	
	densMean/=n*n;
	//divMean/=n0;
	densStd-=densMean*densMean*n*n;
	//divStd -=divMean *divMean*n0;
	densStd/=n*n;
	System.out.println("nelTot "+nelTot);
	nelTot/=L0*L0;
	//divStd/=n0;

	//System.out.println("# n0 "+n0);
	//meanMean/=(n0);
	//meanStd /=(n0);
	
	//	means[0]=meanMean;
	//means[1]=meanStd;
	//means[2]=densStd;
	//means[3]=divStd;
	//means[4]=n0;

	means[0]=divMean;
	//	means[1]=meanStd;
	means[1]=densStd;
	means[2]=nelTot;
	//means[3]=divStd;
	//means[4]=n0;
	return means;

    }


    int2D geoDistance(Bacterium b1, Bacterium b2, int L){
	int distX, distY;
	int[] dist=new int[2];
	int2D out;
	distX=b1.x-b2.x;
	distY=b1.y-b2.y;
	while (distX<-(int)(L/2)) distX+=L;
	while (distX>=(int)(L/2)) distX-=L;
	
	while (distY<-(int)(L/2)) distY+=L;
	while (distY>=(int)(L/2)) distY-=L;
	out=new int2D(distX,distY);
	return out;
    }

    int distance(Bacterium b1, Bacterium b2){
	int i=0;
	int dist=0;
	
	int l1=b1.family.size();
	int l2=b2.family.size();


	//System.out.println(b1.family.toString()+"  "+b2.family.toString());
	
	while (i<l1 && i<l2 && b1.family.elementAt(i)==b2.family.elementAt(i)){
	    i+=1;

	}
	dist=(l1-i)+(l2-i);
	
	return dist;
    }
}



class int2D {
    int x, y;
    public int2D(){
    }
    public void init(int x, int y){
	this.x=x;this.y=y;
    }
    public int2D(int x, int y){
	init(x,y);
    }
}


class Bacterium{
    int x,y,nres;
    double r;
    Vector<Integer> family;
    
    public Bacterium(int x, int y, int nres, double r, Vector<Integer> family){
	this.x=x;this.y=y;this.nres=nres;this.r=r;
	this.family=new Vector<Integer>(family);
    }

    public int historyLength(){
	return family.size();
    }
}

class Pha{
    int x,y,nres;
    public Pha(int x, int y, int nres){
	this.x=x;this.y=y;this.nres=nres;
    }
}